/*
 * $Id: MVELFunctionAdaptor.java 24950 2012-10-15 14:29:31Z svacas $
 * --------------------------------------------------------------------------------------
 * Copyright (c) MuleSoft, Inc.  All rights reserved.  http://www.mulesoft.com
 *
 * The software in this package is published under the terms of the CPAL v1.0
 * license, a copy of which has been included with this distribution in the
 * LICENSE.txt file.
 */

package org.mule.el.mvel;

import org.mule.api.el.ExpressionLanguageContext;
import org.mule.api.el.ExpressionLanguageFunction;

import org.mvel2.ParserContext;
import org.mvel2.ast.Function;
import org.mvel2.integration.VariableResolverFactory;
import org.mvel2.integration.impl.ClassImportResolverFactory;

@SuppressWarnings("serial")
class MVELFunctionAdaptor extends Function
{
    private ExpressionLanguageFunction function;

    public MVELFunctionAdaptor(String name, ExpressionLanguageFunction function, ParserContext parserContext)
    {
        super(name, new char[]{}, new char[]{}, 0, parserContext);
        this.function = function;
    }

    @Override
    public Object call(Object ctx, Object thisValue, VariableResolverFactory factory, Object[] parms)
    {
        if (factory instanceof ClassImportResolverFactory)
        {
            factory = factory.getNextFactory();
        }
        return function.call(parms, (ExpressionLanguageContext) factory);
    }

    @Override
    public void checkArgumentCount(int passing)
    {
        // no-op
    }
}
